/***********************************************
 *
 * OG Script Dumper v3.0 by learn_more
 * File: out\a187\script\cam_dump.as
 * Generated: 24-Jul-2012 02:59:37
 * Overgrowth.exe base: 0x400000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// cam.as


/***********************************************
 * Global Functions:
 */

vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x3c2920 (0x7c2920)


/***********************************************
 * Objects:
 */

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0xc07b0 (0x4c07b0)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0xc07e0 (0x4c07e0)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3c2da0 (0x7c2da0)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x3c34e0 (0x7c34e0)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3c3270 (0x7c3270)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3c3160 (0x7c3160)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3c3540 (0x7c3540)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x3c3030 (0x7c3030)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3c2d50 (0x7c2d50)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3c3510 (0x7c3510)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x3c2dd0 (0x7c2dd0)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x3c2f00 (0x7c2f00)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x3c2970 (0x7c2970)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x3c2470 (0x7c2470)
};

class GUI
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	uint32 AddGUI(string, string, int, int, uint8);		// 'Overgrowth.exe' + 0x256a20 (0x656a20)
	void RemoveGUI(uint32);		// 'Overgrowth.exe' + 0x2558b0 (0x6558b0)
	void RemoveAll();		// 'Overgrowth.exe' + 0x255800 (0x655800)
	void Execute(uint32, string);		// 'Overgrowth.exe' + 0x255910 (0x655910)
	void MoveTo(uint32, int, int);		// 'Overgrowth.exe' + 0x256830 (0x656830)
	string GetCallback(uint32);		// 'Overgrowth.exe' + 0x2568a0 (0x6568a0)
	void Update();		// 'Overgrowth.exe' + 0x25b1c0 (0x65b1c0)
};

class CameraObject
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	bool controlled;		// byteOffset: 0x84
	vec3 position;		// byteOffset: 0x88
	bool frozen;		// byteOffset: 0xd4
	vec3 velocity;		// byteOffset: 0xd8
	bool ignore_mouse_input;		// byteOffset: 0xe8
//-----
	void LoadParallaxScene(string, string);		// 'Overgrowth.exe' + 0x2b60b0 (0x6b60b0)
	void UnloadParallaxScene();		// 'Overgrowth.exe' + 0x2b6060 (0x6b6060)
};

class CameraAnimationReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void AttachTo(string);		// 'Overgrowth.exe' + 0x388870 (0x788870)
	vec3 GetPosition();		// 'Overgrowth.exe' + 0x3886d0 (0x7886d0)
	vec4 GetRotationVec4();		// 'Overgrowth.exe' + 0x388660 (0x788660)
	float GetLens();		// 'Overgrowth.exe' + 0x3886b0 (0x7886b0)
	void Update();		// 'Overgrowth.exe' + 0x388cf0 (0x788cf0)
	bool valid();		// 'Overgrowth.exe' + 0x386c30 (0x786c30)
};



/***********************************************
 * Global Properties:
 */

ASCollisions col;		// 0x220171f8
SphereCollision sphere_col;		// 0x220171fc
GUI gui;		// 0x22017750
uint8 _GG_IGNORES_MOUSE;		// 'Overgrowth.exe' + 0x446cac (0x846cac)
CameraObject co;		// 0x1db55608
CameraAnimationReader camera_animation_reader;		// 0x1db556f4
