/***********************************************
 *
 * OG Script Dumper v3.0 by learn_more
 * File: out\a187\script\playercontrol_dump.as
 * Generated: 24-Jul-2012 02:59:37
 * Overgrowth.exe base: 0x400000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// enemycontrol.as
	// aschar.as
	// situationawareness.as
	// interpdirection.as
	// aircontrols.as
	// fliproll.as
	// ledgegrab.as
	// playercontrol.as


/***********************************************
 * Global Functions:
 */

NavPath __cdecl GetPath(vec3, vec3)			// 'Overgrowth.exe' + 0x255dc0 (0x655dc0)
vec3 __cdecl NavRaycast(vec3, vec3)			// 'Overgrowth.exe' + 0x2557b0 (0x6557b0)
vec3 __cdecl NavPoint(vec3)			// 'Overgrowth.exe' + 0x255770 (0x655770)
void __cdecl SendMessage(int, int, vec3, vec3)			// 'Overgrowth.exe' + 0x2566a0 (0x6566a0)
void __cdecl SendMessage(int, string)			// 'Overgrowth.exe' + 0x257770 (0x657770)
vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x3c2920 (0x7c2920)


/***********************************************
 * Objects:
 */

class Level
{		// size: 0x0, flags:  asOBJ_REF
	int QueryIntFunction(string);		// 'Overgrowth.exe' + 0x3bf9b0 (0x7bf9b0)
	int GetNumObjectives();		// 'Overgrowth.exe' + 0x3bf3d0 (0x7bf3d0)
	int GetNumAchievements();		// 'Overgrowth.exe' + 0x3bf3a0 (0x7bf3a0)
	const string &GetObjective(int);		// 'Overgrowth.exe' + 0x3bf780 (0x7bf780)
	const string &GetAchievement(int);		// 'Overgrowth.exe' + 0x3bf690 (0x7bf690)
	void Execute(string);		// 'Overgrowth.exe' + 0x3bf400 (0x7bf400)
};

class NavPath
{		// size: 0x14, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	bool success;		// byteOffset: 0x10
//-----
	int NumPoints();		// 'Overgrowth.exe' + 0x3c4630 (0x7c4630)
	vec3 GetPoint(int);		// 'Overgrowth.exe' + 0x3c4650 (0x7c4650)
};

class ScriptParams
{		// size: 0x0, flags:  asOBJ_REF
	const string &GetString (const string &in);		// 'Overgrowth.exe' + 0x25f910 (0x65f910)
	float GetFloat (string);		// 'Overgrowth.exe' + 0x25f790 (0x65f790)
	int GetInt (string);		// 'Overgrowth.exe' + 0x25f620 (0x65f620)
	void AddInt (string, int);		// 'Overgrowth.exe' + 0x25f2b0 (0x65f2b0)
	void AddFloat (string, float);		// 'Overgrowth.exe' + 0x25f110 (0x65f110)
	void AddString (string, string);		// 'Overgrowth.exe' + 0x25ef50 (0x65ef50)
};

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0xc07b0 (0x4c07b0)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0xc07e0 (0x4c07e0)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3c2da0 (0x7c2da0)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x3c34e0 (0x7c34e0)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3c3270 (0x7c3270)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3c3160 (0x7c3160)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3c3540 (0x7c3540)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x3c3030 (0x7c3030)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3c2d50 (0x7c2d50)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3c3510 (0x7c3510)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x3c2dd0 (0x7c2dd0)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x3c2f00 (0x7c2f00)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x3c2970 (0x7c2970)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x3c2470 (0x7c2470)
};

class CharacterScriptGetter
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void Load(string);		// 'Overgrowth.exe' + 0x3c0a10 (0x7c0a10)
	string GetObjPath();		// 'Overgrowth.exe' + 0x3c0600 (0x7c0600)
	string GetSkeletonPath();		// 'Overgrowth.exe' + 0x3c05d0 (0x7c05d0)
	string GetAnimPath(string);		// 'Overgrowth.exe' + 0x3c0900 (0x7c0900)
	string GetAttackPath(string);		// 'Overgrowth.exe' + 0x3c07f0 (0x7c07f0)
	void GetTeamString(string &out);		// 'Overgrowth.exe' + 0x3c0630 (0x7c0630)
	float GetHearing();		// 'Overgrowth.exe' + 0x3c0590 (0x7c0590)
};

class ReactionScriptGetter
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void Load(string);		// 'Overgrowth.exe' + 0x3be8a0 (0x7be8a0)
	string GetAnimPath(float);		// 'Overgrowth.exe' + 0x3be870 (0x7be870)
	int GetMirrored();		// 'Overgrowth.exe' + 0x3be850 (0x7be850)
};

class AttackScriptGetter
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void Load(string);		// 'Overgrowth.exe' + 0x23ccc0 (0x63ccc0)
	string GetPath();		// 'Overgrowth.exe' + 0x23c690 (0x63c690)
	string GetSpecial();		// 'Overgrowth.exe' + 0x23cae0 (0x63cae0)
	string GetUnblockedAnimPath();		// 'Overgrowth.exe' + 0x23cba0 (0x63cba0)
	string GetBlockedAnimPath();		// 'Overgrowth.exe' + 0x23cb70 (0x63cb70)
	string GetThrowAnimPath();		// 'Overgrowth.exe' + 0x23cb40 (0x63cb40)
	string GetThrownAnimPath();		// 'Overgrowth.exe' + 0x23cb10 (0x63cb10)
	string GetThrownCounterAnimPath();		// 'Overgrowth.exe' + 0x23c6c0 (0x63c6c0)
	int IsThrow();		// 'Overgrowth.exe' + 0x23c7c0 (0x63c7c0)
	int GetHeight();		// 'Overgrowth.exe' + 0x23cad0 (0x63cad0)
	vec3 GetCutPlane();		// 'Overgrowth.exe' + 0x23c7a0 (0x63c7a0)
	int GetCutPlaneType();		// 'Overgrowth.exe' + 0x23c790 (0x63c790)
	bool HasCutPlane();		// 'Overgrowth.exe' + 0x23c780 (0x63c780)
	vec3 GetStabDir();		// 'Overgrowth.exe' + 0x23c760 (0x63c760)
	int GetStabDirType();		// 'Overgrowth.exe' + 0x23c750 (0x63c750)
	bool HasStabDir();		// 'Overgrowth.exe' + 0x23c740 (0x63c740)
	int GetDirection();		// 'Overgrowth.exe' + 0x23cac0 (0x63cac0)
	int GetSwapStance();		// 'Overgrowth.exe' + 0x23cab0 (0x63cab0)
	int GetSwapStanceBlocked();		// 'Overgrowth.exe' + 0x23caa0 (0x63caa0)
	int GetUnblockable();		// 'Overgrowth.exe' + 0x23ca90 (0x63ca90)
	int GetFleshUnblockable();		// 'Overgrowth.exe' + 0x23c730 (0x63c730)
	int GetAsLayer();		// 'Overgrowth.exe' + 0x23c720 (0x63c720)
	string GetAlternate();		// 'Overgrowth.exe' + 0x23c6f0 (0x63c6f0)
	string GetReactionPath();		// 'Overgrowth.exe' + 0x23ca00 (0x63ca00)
	string GetMaterialEvent();		// 'Overgrowth.exe' + 0x23ca60 (0x63ca60)
	vec3 GetImpactDir();		// 'Overgrowth.exe' + 0x23cbd0 (0x63cbd0)
	float GetBlockDamage();		// 'Overgrowth.exe' + 0x23c980 (0x63c980)
	float GetSharpDamage();		// 'Overgrowth.exe' + 0x23c900 (0x63c900)
	float GetDamage();		// 'Overgrowth.exe' + 0x23c880 (0x63c880)
	float GetForce();		// 'Overgrowth.exe' + 0x23c800 (0x63c800)
	int GetMirrored();		// 'Overgrowth.exe' + 0x23c680 (0x63c680)
	int GetMobile();		// 'Overgrowth.exe' + 0x23c7f0 (0x63c7f0)
};

class PathScriptReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	int GetNearestPoint(vec3);		// 'Overgrowth.exe' + 0x3bef90 (0x7bef90)
	vec3 GetPointPosition(int);		// 'Overgrowth.exe' + 0x3bef70 (0x7bef70)
	int GetConnectedPoint(int);		// 'Overgrowth.exe' + 0x3bef50 (0x7bef50)
	int GetOtherConnectedPoint(int, int);		// 'Overgrowth.exe' + 0x3bef30 (0x7bef30)
};



/***********************************************
 * Global Properties:
 */

Level level;		// 'Overgrowth.exe' + 0x54a670 (0x94a670)
int _plant_movement_msg;		// 'Overgrowth.exe' + 0x446e58 (0x846e58)
int _editor_msg;		// 'Overgrowth.exe' + 0x446e5c (0x846e5c)
ScriptParams params;		// 0x18d46504
ASCollisions col;		// 0x18c8a2e0
SphereCollision sphere_col;		// 0x18c8a2e4
MovementObject this_mo;		// 0x18d46490
uint8 _ANM_MIRRORED;		// 'Overgrowth.exe' + 0x5471d6 (0x9471d6)
uint8 _ANM_MOBILE;		// 'Overgrowth.exe' + 0x5471d7 (0x9471d7)
uint8 _ANM_SUPER_MOBILE;		// 'Overgrowth.exe' + 0x5471d8 (0x9471d8)
uint8 _ANM_SWAP;		// 'Overgrowth.exe' + 0x5471d9 (0x9471d9)
uint8 _ANM_FROM_START;		// 'Overgrowth.exe' + 0x5471da (0x9471da)
CharacterScriptGetter character_getter;		// 0x18d4661c
ReactionScriptGetter reaction_getter;		// 0x18d46580
AttackScriptGetter attack_getter;		// 0x18d465a4
const int _high; // = 0
const int _medium; // = 1
const int _low; // = 2
const int _right; // = 0
const int _front; // = 1
const int _left; // = 2
AttackScriptGetter attack_getter2;		// 0x18d465e0
PathScriptReader path_script_reader;		// 0x18d46630
